SystemOrganization addCategory: #SoftwareDesign!
SystemOrganization addCategory: #'SoftwareDesign-Model'!

RectangleMorph subclass: #SDNavGraph
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/18/2012 18:12'!
addNode: aNode

	self nodes add: aNode.
	
	self addMorph: aNode. 
	aNode extent: 30@30; 
		position: self position + (aNode gridPosition * 50).
	
	self drawEdgesFor: aNode.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/18/2012 18:15'!
drawEdgesFor: aNode

	aNode edges do: [ :edge |
		edge 
		].
! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/18/2012 18:09'!
initialize

	super initialize.
	
	self position: (200@200);
		color: Color white;
		extent: 800@600.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/18/2012 15:43'!
nodes
	
	nodes ifNil: [
		nodes := OrderedCollection new.].
	
	^ nodes! !

CircleMorph subclass: #SDNavNode
	instanceVariableNames: 'gridPosition name edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavNode class methodsFor: 'class initialization' stamp: 'GNS 11/18/2012 15:41'!
createWithName: aName

	| node |
	
	node := SDNavNode new.
	node name: aName.		
	
	^ node ! !

!SDNavNode class methodsFor: 'class initialization' stamp: 'GNS 11/18/2012 16:59'!
createWithName: aName on: aPoint

	| node |
	
	node := SDNavNode new.
	node name: aName.	
	node gridPosition: aPoint.	
	
	^ node ! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:32'!
addConnectionTo: aNode withWeight: aWeight

	| edge |
	
	edge := SDNavEdge new.
	edge from: self.
	edge to: aNode.
	edge weights: aWeight.		
	
	self edges add: edge.
	
	^ edge! !

!SDNavNode methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 13:45'!
distanceTo: aNode

	
	self edges do: [ :edge |
		(edge to = aNode) ifTrue: [^ edge weights ]
		].
	^ 1000! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:26'!
edges
	"Answer the value of edges"
	
	edges ifNil: [
		edges := OrderedCollection new.].
	
	^ edges! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 16:59'!
edges: anObject
	"Set the value of edges"

	edges := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 17:13'!
gridPosition
	"Answer the value of gridposition"

	^ gridPosition! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 17:13'!
gridPosition: anObject
	"Set the value of gridposition"

	gridPosition := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:54'!
name: anObject
	"Set the value of name"

	name := anObject! !

LineMorph subclass: #SDNavEdge
	instanceVariableNames: 'from to weights'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavEdge class methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 12:21'!
createFrom: aSource to: aDestination withWeight: aWeight

	| edge |
	
	edge := SDNavEdge new.
	edge from: aSource.
	aSource edges add: edge.
	edge to: aDestination.
	edge weights: aWeight.		
	
	^ edge ! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:52'!
from
	"Answer the value of from"

	^ from! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:52'!
from: anObject
	"Set the value of from"

	from := anObject! !

!SDNavEdge methodsFor: 'as yet unclassified' stamp: 'GNS 11/13/2012 19:03:12.437'!
initialize 

	super initialize.
	
	connectingNodes := OrderedCollection new.! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:52'!
to
	"Answer the value of to"

	^ to! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:52'!
to: anObject
	"Set the value of to"

	to := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:20'!
weights
	"Answer the copy of the weights"

	^ weights! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:52'!
weights: anObject
	"Set the value of weights"

	weights := anObject! !

Object subclass: #SDBerlinSBahnGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDBerlinSBahnGraph class methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 12:33'!
createGraph
	| graph nodeA nodeB nodeC nodeD nodeE |
	
	graph := SDNavGraph new.
	
	
	nodeA := SDNavNode createWithName: 'NodeA'.
	nodeB := SDNavNode createWithName: 'NodeB'.   
	nodeC := SDNavNode createWithName: 'NodeC'.
	nodeD := SDNavNode createWithName: 'NodeD'.   
	nodeE := SDNavNode createWithName: 'NodeE'.
	
	nodeA addConnectionTo: nodeB withWeight: 1.
	nodeA addConnectionTo: nodeC withWeight: 1.
	nodeC addConnectionTo: nodeD withWeight: 1.
	nodeD addConnectionTo: nodeE withWeight: 1.
	nodeE addConnectionTo: nodeA withWeight: 1.   
	
	graph addNode: nodeA.
	graph addNode: nodeB.
	graph addNode: nodeC.
	graph addNode: nodeD.
	graph addNode: nodeE.
	
	^ graph! !

Object subclass: #SDNavDijkstra
	instanceVariableNames: 'name count edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

Object subclass: #SDNavDijkstraAlgorithm
	instanceVariableNames: 'startNode graph distances visitedNodes unvisitedNodes predecessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:56'!
distances
	"Answer the value of distance"
	
	distances ifNil: [
		distances := Dictionary new.].
	
	^ distances! !

!SDNavDijkstraAlgorithm methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 16:21'!
execute: aStartNode

	self distances at: aStartNode put: 0.
	self unvisitedNodes add: aStartNode.
	
	[self unvisitedNodes size > 0] whileTrue: [ | aNode |
		
		aNode := self getMininumOfUnVisitedNodes.
		self visitedNodes add: aNode.
		self unvisitedNodes remove: aNode.
		self findMinimalDistances: aNode.].! !

!SDNavDijkstraAlgorithm methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 16:18'!
findMinimalDistances: aNode

	| unvisitedNeighbors |
	
	unvisitedNeighbors := self unvisitedNeighborsOf: aNode.
	unvisitedNeighbors do: [ :unvisitedNeighbor |
		
		| tempDistance |
		tempDistance := (self shortestDistanceOf: aNode) + (aNode distanceTo: unvisitedNeighbor).
		
		((self shortestDistanceOf: unvisitedNeighbor) > tempDistance ) ifTrue: [
			self distances at: unvisitedNeighbor put: tempDistance.
			self predecessors at: unvisitedNeighbor put: aNode.
			self unvisitedNodes add: unvisitedNeighbor.].
	].! !

!SDNavDijkstraAlgorithm methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 16:17'!
getMininumOfUnVisitedNodes
	
	| minimum |
	
	minimum := nil.
	
	self unvisitedNodes do: [ :unvisitedNode |
		minimum
			ifNil: [minimum := unvisitedNode.]
			ifNotNil: [
				((self shortestDistanceOf: unvisitedNode)
					< (self shortestDistanceOf: minimum)) ifTrue: [minimum := unvisitedNode.]].	].
	^ minimum! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:51'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:51'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:58'!
predecessors
	"Answer the value of predecessors"

	predecessors ifNil: [
		predecessors := Dictionary new.].
	
	^ predecessors! !

!SDNavDijkstraAlgorithm methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 16:17'!
shortestDistanceOf: aNode
	
	| distance |
	distance := self distances at: aNode ifAbsent: [ ^ 10000].
	^ distance.
	! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:51'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:51'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

!SDNavDijkstraAlgorithm methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 16:08'!
unvisitedNeighborsOf: aNode

	| unvisitedNeighbors |
	
	unvisitedNeighbors := OrderedCollection new.
	
	aNode edges do: [ :anEdge |
		
		| destinationNode |
		destinationNode := anEdge to.
		
		(self visitedNodes includes: destinationNode) ifFalse: [
			unvisitedNeighbors add: destinationNode.].
		].
	
	^ unvisitedNeighbors  ! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/18/2012 13:01'!
unvisitedNodes
	"Answer the value of unvisitedNodes"

	unvisitedNodes ifNil: [
		unvisitedNodes := Set new.].
	
	^ unvisitedNodes! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/18/2012 13:01'!
visitedNodes
	"Answer the value of visitedNodes"

	visitedNodes ifNil: [
		visitedNodes := Set new.].
	
	^ visitedNodes! !

Object subclass: #SDNavLittleSampleGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavLittleSampleGraph class methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 16:58'!
createGraph
	| graph nodeA nodeB nodeC |
	
	graph := SDNavGraph new.
	
	
	nodeA := SDNavNode createWithName: 'A' on: 3@5.
	nodeB := SDNavNode createWithName: 'B' on: 4@2.   
	nodeC := SDNavNode createWithName: 'C' on: 3@3.
	
	nodeA addConnectionTo: nodeB withWeight: 2.
	nodeA addConnectionTo: nodeC withWeight: 5.
	nodeB addConnectionTo: nodeC withWeight: 2.
	   
	
	graph addNode: nodeA.
	graph addNode: nodeB.
	graph addNode: nodeC.
	
	^ graph! !

SystemWindow subclass: #SDNavMainWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!SDNavMainWindow methodsFor: 'as yet unclassified' stamp: 'GNS 11/18/2012 16:35'!
initialize
	| rectangle |
	
	
	super initialize.
	
	self setLabel: 'Navigation System'.
	
	rectangle := PasteUpMorph new.
	rectangle color: Color yellow.
	rectangle referencePosition: self position + (12 @ 30).
	rectangle topLeft: self position + (12 @ 30).
	"rectangle bounds: (300@150)."
	
	"loadButton := SimpleButtonMorph new.
	loadButton label: 'Load little Map'.
	self addMorph: loadButton."
	
	
	self addMorph: rectangle.
	  
	
	
	
	
	! !
